<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Generate ANSI C code for proportional fonts-->
<!-- Histroy:-->
<!-- 03.04.2010 Bug Fix [FB]: Changed absolut to relativ path in template recursivLength to get bytesperbitmap -->

<xsl:stylesheet
	version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xsl:output method="text" encoding="ISO-8859-1"/>
	<xsl:strip-space elements="*"/>

	<xsl:template match="/">
		 <xsl:apply-templates select="//project"/>
		 <xsl:apply-templates select="//project/group"/>
	</xsl:template>

	<!-- Generate Preambel -->
	<xsl:template match="project">
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>//               Font and Bitmap Generator                      &#xa;</xsl:text>
		<xsl:text>//                                                              &#xa;</xsl:text>
		<xsl:text>// 					   www.muGUI.de                           &#xa;</xsl:text> 
		<xsl:text>//                                                              &#xa;</xsl:text>
		<xsl:text>// Version:   </xsl:text>
		<xsl:value-of select="version"/> 
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Project Name:  </xsl:text>
		<xsl:value-of select="projectname"/> 
		<xsl:text>&#xa;</xsl:text>	
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>// Generated by mugui2c.xsl, Copyright 07.11.2009               &#xa;</xsl:text>
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>&#xa;</xsl:text>
	</xsl:template> 


	<xsl:template match="/project/group">

		<xsl:variable name="StrtCharacter">
			<xsl:value-of select="startcharacter"/>
		</xsl:variable>

		<xsl:variable name="StopCharacter">
			<xsl:value-of select="startcharacter + numberofbitmaps -1"/>
		</xsl:variable>
		<xsl:variable name="Bytesperbitmap">
			<xsl:value-of select="bytesperbitmapline"/>
		</xsl:variable>
		<xsl:variable name="Width">
			<xsl:value-of select="width"/>
		</xsl:variable>
		<xsl:variable name="Height">
			<xsl:value-of select="height"/>
		</xsl:variable>

		<xsl:variable name="hewi" select="floor($Height * $Width div 8)" />

		<xsl:variable name="Index">0</xsl:variable>


		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>// Group Name       : </xsl:text>
		<xsl:value-of select="groupname"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Designer         : </xsl:text>
		<xsl:value-of select="designer"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Date             : </xsl:text>
		<xsl:value-of select="date"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Description      : </xsl:text>
		<xsl:value-of select="description"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Byte orientation : </xsl:text>
		<xsl:value-of select="byteorientation"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:if test="contains(proportional,'True')">
			<xsl:text>// Proportional font &#xa;</xsl:text>
			<xsl:text>// Font Width       : Individual &#xa;</xsl:text>
		</xsl:if>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>// Monospace font &#xa;</xsl:text>
			<xsl:text>// Font Width       : </xsl:text>
			<xsl:value-of select="width"/>
			<xsl:text> Pixels&#xa;</xsl:text>
		</xsl:if>
		<xsl:text>// Font Height      : </xsl:text>
		<xsl:value-of select="height"/>
		<xsl:text> Pixels&#xa;</xsl:text>
		<xsl:text>// Number of Bitmaps: </xsl:text>
		<xsl:value-of select="numberofbitmaps"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>// Bytes per Bitmap : </xsl:text>
			<xsl:value-of select="$hewi"/>
			<xsl:text>&#xa;</xsl:text>
		</xsl:if>
		<xsl:text>// First ASCII code : </xsl:text>
		<xsl:value-of select="startcharacter"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Last ASCII code  : </xsl:text>
		<xsl:value-of select="$StopCharacter - 1"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>//---------------------------------------------------------------&#xa;</xsl:text>
		
		<!-- Make Header -->

<!--		<xsl:text>unsigned char Font[BYTES_PER_PIXEL * FONT_CHAR_COUNT] = &#xa;{&#xa;</xsl:text>-->

		<xsl:text>unsigned char </xsl:text>
		<xsl:value-of select="groupname"/>
		<xsl:text>[</xsl:text>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>(</xsl:text>
			<xsl:value-of select="$hewi"/>
			<xsl:text> * </xsl:text>
			<xsl:value-of select="numberofbitmaps"/>
			<xsl:text>) + 6</xsl:text>
		</xsl:if>
		<xsl:text>] = &#xa;{&#xa;</xsl:text>
		<xsl:text>&#9;// Font Header &#xa;</xsl:text>

		<xsl:if test="contains(proportional,'True')">
			<xsl:text>&#9;0x01,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>&#9;0x00,</xsl:text>
		</xsl:if>
		<xsl:text>&#9;// 0x00: Monospace       - 0x01: Proportional &#xa;</xsl:text>
		
		<xsl:if test="contains(byteorientation,'horizontalLeft')">
			<xsl:text>&#9;0x00,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(byteorientation,'horizontalRight')">
			<xsl:text>&#9;0x01,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(byteorientation,'verticalCeiling')">
			<xsl:text>&#9;0x02,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(byteorientation,'verticalBottom')">
			<xsl:text>&#9;0x03,</xsl:text>
		</xsl:if>
		<xsl:text>&#9;// 0x00: horizontalLeft  - 0x01: horizontalRight &#xa;</xsl:text>
		<xsl:text>&#9;&#9;// 0x02: verticalCeiling - 0x03: verticalBottom &#xa;</xsl:text>
		
		<xsl:text>&#9;0x</xsl:text>
		<xsl:call-template name="toHex">
			<xsl:with-param name="decimalNumber" select="startcharacter" />
		</xsl:call-template>
		<xsl:text>,&#9;// First ASCII code &#xa;</xsl:text>
		
		<xsl:text>&#9;0x</xsl:text>
		<xsl:call-template name="toHex">
			<xsl:with-param name="decimalNumber" select="numberofbitmaps" />
		</xsl:call-template>
		<xsl:text>,&#9;// Number of Bitmaps &#xa;</xsl:text>
		
		<xsl:text>&#9;0x</xsl:text>
		<xsl:call-template name="toHex">
			<xsl:with-param name="decimalNumber" select="height" />
		</xsl:call-template>
		<xsl:text>,&#9;// Height &#xa;</xsl:text>
		
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>&#9;0x</xsl:text>
			<xsl:call-template name="toHex">
				<xsl:with-param name="decimalNumber" select="width" />
			</xsl:call-template>
		<xsl:text>,&#9;// Width &#xa;</xsl:text>
		</xsl:if>
		
		<xsl:text>&#xa;&#xa;</xsl:text>

		<xsl:if test="contains(proportional,'True')">
			<!-- Make Index -->
			<xsl:call-template name="makeIndex">
				<xsl:with-param name="stchar" select="$StrtCharacter" />
			</xsl:call-template>

			<!-- Make Bitmaps -->
			<xsl:for-each select="bitmap">
				<xsl:text>&#9;0x</xsl:text>

				<xsl:call-template name="toHex">
					<xsl:with-param name="decimalNumber" select="bitmapwidth" />
				</xsl:call-template>
				<xsl:text>, </xsl:text>
				<xsl:for-each select="byte">
					<xsl:value-of select="."/>
					<xsl:if test="position()!=last()">
						<xsl:text>,</xsl:text>
					</xsl:if>
					<xsl:if test="(floor(position() div 16) = position() div 16)">
						<xsl:text>&#xa;&#9;      </xsl:text>
					</xsl:if>
				</xsl:for-each>
				<xsl:if test="position()!=last()">
					<xsl:text>,</xsl:text>
				</xsl:if>

				<xsl:variable name="lastline" select="(17 - ((ceiling(bitmapwidth div 8) * $Height) mod 16)) * 5" />
				<xsl:call-template name="RepeatString">
					<xsl:with-param name="string" select="' '" />
					<xsl:with-param name="times"  select="$lastline" />
				</xsl:call-template> 

				<xsl:choose>
					<xsl:when test="position()!=last()">
						<xsl:text> // </xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>  // </xsl:text>
					</xsl:otherwise>
				</xsl:choose>

				<xsl:call-template name="ShowASCII">
					<xsl:with-param name="shascii" select="$StrtCharacter" />
				</xsl:call-template>

				<xsl:text>&#9; Font width: </xsl:text>
					<xsl:value-of select="bitmapwidth"/>
				<xsl:text> pixels in </xsl:text>
					<xsl:value-of select="ceiling(bitmapwidth div 8)"/>
				<xsl:text> byte(s).&#xa;</xsl:text>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="contains(proportional,'False')">
			<!-- Make Bitmaps -->
			<xsl:for-each select="bitmap">
				<xsl:text>&#9;</xsl:text>
				<xsl:for-each select="byte">
					<xsl:value-of select="."/>
					<xsl:if test="position()!=last()">
						<xsl:text>,</xsl:text>
					</xsl:if>
				</xsl:for-each>

				<xsl:if test="position()!=last()">
					<xsl:text>,</xsl:text>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="position()!=last()">
						<xsl:text> // </xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>  // </xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="ShowASCII">
					<xsl:with-param name="shascii" select="$StrtCharacter" />
				</xsl:call-template>
				<xsl:text>&#xa;</xsl:text>

			</xsl:for-each>
		</xsl:if>
		
		<xsl:text>&#xa;};&#xa;</xsl:text>

	</xsl:template>


	<!-- Display corresponding ASCII character -->
	<xsl:template name="ShowASCII">
		<xsl:param name="shascii" />
		<!--                                ................................ !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXUZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~.................................................................................................................................-->
		<xsl:variable name="ascii" select="'................................ !.#$%..()*+,-..0123456789:;.=.?@ABCDEFGHIJKLMNOPQRSTUVWXUZ[.]^_`abcdefghijklmnopqrstuvwxyz{|}~.................................................................................................................................'" />
		<xsl:variable name="n_space" select="33" />
		<xsl:variable name="n_double_quote" select="35" />
		<xsl:variable name="n_ampersand" select="39" />
		<xsl:variable name="n_single_quote" select="40" />
		<xsl:variable name="n_slash" select="48" />
		<xsl:variable name="n_less_than" select="61" />
		<xsl:variable name="n_greater_than" select="63" />
		<xsl:variable name="n_backslash" select="93" />
		<xsl:choose>
			<xsl:when test="$shascii + position() = $n_space">
				<xsl:text>Space</xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_double_quote">
				<xsl:text><![CDATA["]]></xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_ampersand">
				<xsl:text><![CDATA[&]]></xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_single_quote">
				<xsl:text><![CDATA[']]></xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_slash">
				<xsl:text>Slash</xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_less_than">
				<xsl:text><![CDATA[<]]></xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_greater_than">
				<xsl:text><![CDATA[>]]></xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_backslash">
				<xsl:text>Backslash</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="substring($ascii, $shascii + position(), 1)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>





	<!-- Convert Dezimal to Hex --> 
	<xsl:variable name="hexDigits" select="'0123456789ABCDEF'" />
	<xsl:template name="toHex">
		<xsl:param name="decimalNumber" />
		<xsl:choose>
			<xsl:when test="$decimalNumber >= 16">
				<xsl:value-of select="substring($hexDigits,floor($decimalNumber div 16) + 1,1)"/>
				<xsl:value-of select="substring($hexDigits,floor($decimalNumber mod 16) + 1,1)"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>0</xsl:text>
				<xsl:value-of select="substring($hexDigits,$decimalNumber + 1,1)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Make the index with start address of the bitmaps -->
	<xsl:template name="makeIndex">
		<xsl:param name="stchar" />
		<xsl:text>&#9;// Bitmap Index: Number of Index Entries </xsl:text>
			<xsl:value-of  select="count(bitmap)"/>
		<xsl:text>&#xa; </xsl:text>
		
		<xsl:variable name="mcount" select="count(bitmap)*2"/>

		<xsl:for-each select="bitmap">
			<xsl:variable name="laenge">
				<xsl:call-template name="recursivLength">
					<xsl:with-param name="n">
						<xsl:value-of select="position()"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:variable>

			<!-- length of data bytes, Index length, Header (5 Bytes but starting with 0 ->2)  -->
			<xsl:variable name="Highbyte">
					<xsl:value-of select="floor(($laenge + $mcount + 5) div 256)"/>
			</xsl:variable>
			
					
			<xsl:variable name="Lowbyte">
					<xsl:value-of select="($laenge + $mcount + 5) mod 256"/>
			</xsl:variable>
			<xsl:text>&#9;0x</xsl:text>
			
			<xsl:call-template name="toHex">
				<xsl:with-param name="decimalNumber" select="$Highbyte" />
			</xsl:call-template>

			<xsl:text>, 0x</xsl:text>
			
			<xsl:call-template name="toHex">
				<xsl:with-param name="decimalNumber" select="$Lowbyte" />
			</xsl:call-template>


			<xsl:text>, // </xsl:text>

			<xsl:call-template name="ShowASCII">
				<xsl:with-param name="shascii" select="$stchar" />
			</xsl:call-template>
			<xsl:text>&#xa;</xsl:text>
		</xsl:for-each>
		<xsl:text>&#xa;</xsl:text>
	</xsl:template>

	<!-- Calculate the bitmap bytes from bitmap 1 to bitmap n -->
	<!-- Remember: XSLT starts indexing with 1 and not with 0 -->
	<xsl:template name="recursivLength">
	   <xsl:param name="n"/>
	   <xsl:if test="$n > 1"> 
				<xsl:variable name="Width" >
					<xsl:call-template name="recursivLength">
						<xsl:with-param name="n" select="$n - 1"/>
					</xsl:call-template>
				</xsl:variable> 
				<xsl:variable name="BytesPerBitmap">
					<xsl:value-of select="../bitmap[$n]/bytesperbitmap" />
				</xsl:variable>
				<xsl:value-of select="$Width + $BytesPerBitmap + 1" />
	   </xsl:if>
	   <xsl:if test="$n = 1"> 
			<xsl:variable name="Width" >0</xsl:variable> 
			<xsl:value-of select="$Width" />
	   </xsl:if>
	</xsl:template>



	<xsl:template name="RepeatString">
		<xsl:param name="string" select="''" />
		<xsl:param name="times"  select="1" />
		<xsl:if test="number($times) &gt; 0">
			<xsl:value-of select="$string" />
			<xsl:call-template name="RepeatString">
				<xsl:with-param name="string" select="$string" />
				<xsl:with-param name="times"  select="$times - 1" />
			</xsl:call-template>
		</xsl:if>
	</xsl:template> 



 </xsl:stylesheet>