<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Generate ANSI C code for proportional fonts-->
<!-- Histroy:-->
<!-- 03.04.2010 Bug Fix [FB]: Changed absolut to relativ path in template recursivLength to get bytesperbitmap -->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema">
    <xsl:output method="text" encoding="ISO-8859-1"/>
    <xsl:strip-space elements="*"/>

    <xsl:template match="/">
		 <xsl:apply-templates select="//project"/>
		 <xsl:apply-templates select="//project/group"/>
	</xsl:template>

	<!-- Generate Preambel -->
	<xsl:template match="project">
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>//               Font and Bitmap Generator                      &#xa;</xsl:text>
		<xsl:text>//                                                              &#xa;</xsl:text>
		<xsl:text>// 					   www.muGUI.de                           &#xa;</xsl:text> 
		<xsl:text>//                                                              &#xa;</xsl:text>
		<xsl:text>// Version:   </xsl:text>
		<xsl:value-of select="version"/> 
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Project Name:  </xsl:text>
		<xsl:value-of select="projectname"/> 
		<xsl:text>&#xa;</xsl:text>	
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>// Generated by mugui2c.xsl, Copyright 07.11.2009               &#xa;</xsl:text>
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
    	<xsl:text>// Stylesheet modified 03.16.2014 DT Mort / Frank Vannieuwkerke &#xa;</xsl:text>
		<xsl:text>// Header: Always 6 words long (mono or proportional)           &#xa;</xsl:text>
		<xsl:text>//         Width= 0x000 if proportional (individual, Index-1)   &#xa;</xsl:text>
		<xsl:text>//         Index= points to 1st graphic element (width=Index-1) &#xa;</xsl:text>
		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>&#xa;</xsl:text>
	</xsl:template> 


	<xsl:template match="/project/group">

		<xsl:variable name="StrtCharacter">
			<xsl:value-of select="startcharacter"/>
		</xsl:variable>

		<xsl:variable name="StopCharacter">
			<xsl:value-of select="startcharacter + numberofbitmaps -1"/>
		</xsl:variable>
		<xsl:variable name="Bytesperbitmap">
			<xsl:value-of select="bytesperbitmapline"/>
		</xsl:variable>
		<xsl:variable name="Width">
			<xsl:value-of select="width"/>
		</xsl:variable>
		<xsl:variable name="Height">
			<xsl:value-of select="height"/>
		</xsl:variable>

<!--    Non-Proportional fonts:
        <xsl:variable name="hewi" select="floor($Height * $Width div 8)" />
        Above code calculates the correct bytes per bitmap but the bytes/bitmap
        value in the bitmap itself is larger for certain width/height values.
        eg :    13 x 13 pixels = 21 bytes/bitmap (calculated) but the 'bytesperbitmap'
                value in each bitmap is 26 AND 26 bytes are present.
        As a workaround, the'bytesperbitmap' value is read from the first bitmap
        and stored in the 'hewi' variable.
        ? Is there a bug in the Font and Bitmap Generator ?
         -->
        <xsl:variable name="hewi">
            <xsl:for-each select="bitmap[1]">
            	<xsl:value-of select="bytesperbitmap"/>
        	</xsl:for-each>
    	</xsl:variable>
		<xsl:variable name="Index">0</xsl:variable>


		<xsl:text>//--------------------------------------------------------------&#xa;</xsl:text>
		<xsl:text>// Group Name       : </xsl:text>
		<xsl:value-of select="groupname"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Designer         : </xsl:text>
		<xsl:value-of select="designer"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Date             : </xsl:text>
		<xsl:value-of select="date"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Description      : </xsl:text>
		<xsl:value-of select="description"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Byte orientation : </xsl:text>
		<xsl:value-of select="byteorientation"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:if test="contains(proportional,'True')">
			<xsl:text>// Proportional font: yes &#xa;</xsl:text>
			<xsl:text>// Font Width       : Individual &#xa;</xsl:text>
		</xsl:if>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>// Monospace font &#xa;</xsl:text>
			<xsl:text>// Font Width       : </xsl:text>
			<xsl:value-of select="width"/>
			<xsl:text> Pixels&#xa;</xsl:text>
		</xsl:if>
		<xsl:text>// Font Height      : </xsl:text>
		<xsl:value-of select="height"/>
		<xsl:text> Pixels&#xa;</xsl:text>
		<xsl:text>// Number of Bitmaps: </xsl:text>
		<xsl:value-of select="numberofbitmaps"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>// Bytes per Bitmap : </xsl:text>
        	<xsl:value-of select="$hewi"/>
			<xsl:text>&#xa;</xsl:text>
		</xsl:if>
		<xsl:text>// First ASCII code : </xsl:text>
		<xsl:value-of select="startcharacter"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>// Last ASCII code  : </xsl:text>
		<xsl:value-of select="$StopCharacter - 1"/>
		<xsl:text>&#xa;</xsl:text>
		<xsl:text>//---------------------------------------------------------------&#xa;</xsl:text>
		
		<!-- Make Header -->

<!--		<xsl:text>const uint16_t Font[BYTES_PER_PIXEL * FONT_CHAR_COUNT] = &#xa;{&#xa;</xsl:text>-->

		<xsl:text>const uint16_t </xsl:text>
		<xsl:value-of select="groupname"/>
		<xsl:text>[</xsl:text>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>(</xsl:text>
			<xsl:value-of select="$hewi div 2"/>
			<xsl:text> * </xsl:text>
			<xsl:value-of select="numberofbitmaps"/>
			<xsl:text>) + 6</xsl:text>
		</xsl:if>
		<xsl:text>] = &#xa;{&#xa;</xsl:text>
		<xsl:text>&#9;// Font Header &#xa;</xsl:text>

		<xsl:if test="contains(proportional,'True')">
			<xsl:text>&#9;0x0001,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>&#9;0x0000,</xsl:text>
		</xsl:if>
		<xsl:text>&#9;// 0x0000: Monospace       - 0x0001: Proportional &#xa;</xsl:text>
		
		<xsl:if test="contains(byteorientation,'horizontalLeft')">
			<xsl:text>&#9;0x0000,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(byteorientation,'horizontalRight')">
			<xsl:text>&#9;0x0001,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(byteorientation,'verticalCeiling')">
			<xsl:text>&#9;0x0002,</xsl:text>
		</xsl:if>
		<xsl:if test="contains(byteorientation,'verticalBottom')">
			<xsl:text>&#9;0x0003,</xsl:text>
		</xsl:if>
		<xsl:text>&#9;// 0x0000: horizontalLeft  - 0x0001: horizontalRight &#xa;</xsl:text>
		<xsl:text>&#9;        // 0x0002: verticalCeiling - 0x0003: verticalBottom &#xa;</xsl:text>
		
		<xsl:text>&#9;0x</xsl:text>
    	<xsl:call-template name="AddZero">
			<xsl:with-param name="n" select="startcharacter" />
		</xsl:call-template>
		<xsl:call-template name="toHex">
			<xsl:with-param name="decimalNumber" select="startcharacter" />
		</xsl:call-template>
		<xsl:text>,&#9;// First ASCII code &#xa;</xsl:text>
		
		<xsl:text>&#9;0x</xsl:text>
        <xsl:call-template name="AddZero">
			<xsl:with-param name="n" select="numberofbitmaps" />
		</xsl:call-template>
		<xsl:call-template name="toHex">
			<xsl:with-param name="decimalNumber" select="numberofbitmaps" />
		</xsl:call-template>
		<xsl:text>,&#9;// Number of Bitmaps &#xa;</xsl:text>
		
		<xsl:text>&#9;0x</xsl:text>
        <xsl:call-template name="AddZero">
    		<xsl:with-param name="n" select="height" />
		</xsl:call-template>
		<xsl:call-template name="toHex">
			<xsl:with-param name="decimalNumber" select="height" />
		</xsl:call-template>
		<xsl:text>,&#9;// Height &#xa;</xsl:text>
		
		<xsl:if test="contains(proportional,'False')">
			<xsl:text>&#9;0x</xsl:text>
            <xsl:call-template name="AddZero">
            	<xsl:with-param name="n" select="width" />
		    </xsl:call-template>
			<xsl:call-template name="toHex">
				<xsl:with-param name="decimalNumber" select="width" />
			</xsl:call-template>
		<xsl:text>,&#9;// Width &#xa;</xsl:text>
		</xsl:if>

		<xsl:if test="contains(proportional,'True')">
			<xsl:text>&#9;0x0000</xsl:text>
			<xsl:text>,&#9;// Width invalid: use individual (Index - 1)&#xa;</xsl:text>
		</xsl:if>
		
		<xsl:text>&#xa;&#xa;</xsl:text>

		<xsl:if test="contains(proportional,'True')">
			<!-- Make Index -->
			<xsl:call-template name="makeIndex">
				<xsl:with-param name="stchar" select="$StrtCharacter" />
			</xsl:call-template>
<!-- Make Bitmaps -->
			<xsl:for-each select="bitmap">



				<xsl:text>&#9;0x</xsl:text>
        		<xsl:if test="bitmapwidth &lt; 16">
					<xsl:text>0</xsl:text>
				</xsl:if>
        		<xsl:if test="bitmapwidth &lt; 256">
					<xsl:text>00</xsl:text>
				</xsl:if>
				<xsl:call-template name="toHex">
					<xsl:with-param name="decimalNumber" select="bitmapwidth" />
				</xsl:call-template>
				<xsl:text>, </xsl:text>
                <xsl:for-each select="byte">
			<!-- Revision 3/22/14 to correct build of 16-bit words in 0xHHLL order -->
                    <xsl:if test="position() mod 2 = 0">
                        <xsl:value-of select="concat(.,substring(preceding::byte[1], 3, 2))"/>
                        <xsl:if test="position()!=last()">
                        	<xsl:text>,</xsl:text>
                    	</xsl:if>
        			</xsl:if>
			<!-- end 3/22/14 revision -->
                    <xsl:if test="position()=last() and position() mod 2 = 1">
                        <xsl:value-of select="concat(.,'00')"/>
                    </xsl:if>
		            <xsl:if test="(floor(position() div 16) = position() div 16)">
                        <xsl:if test="position()!=last()">
        			        <xsl:text>&#xa;&#9;        </xsl:text>
                        </xsl:if>
		            </xsl:if>
                </xsl:for-each>

				<xsl:if test="position()!=last()">
					<xsl:text>,</xsl:text>
				</xsl:if>
                <xsl:variable name="lastline">
                    <xsl:choose>
                    	<xsl:when test="bytesperbitmap mod 16 = 0">
                            <xsl:value-of select="0"/>
                        </xsl:when>
                    	<xsl:otherwise>
                            <xsl:value-of select="7 * (8 - (((bytesperbitmap + (bytesperbitmap mod 2)) mod 16) div 2))"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:variable>
                <xsl:call-template name="RepeatString">
    			    <xsl:with-param name="string" select="' '" />
    			    <xsl:with-param name="times"  select="$lastline" />
        	    </xsl:call-template> 
                <xsl:choose>
					<xsl:when test="position()!=last()">
						<xsl:text> // </xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>  // </xsl:text>
					</xsl:otherwise>
				</xsl:choose>

				<xsl:call-template name="ShowASCII">
					<xsl:with-param name="shascii" select="$StrtCharacter" />
				</xsl:call-template>

				<xsl:text>Font width: </xsl:text>
					<xsl:value-of select="bitmapwidth"/>
				<xsl:text> pixels in </xsl:text>
					<xsl:value-of select="ceiling(bitmapwidth div 8)"/>
				<xsl:text> byte(s).&#xa;</xsl:text>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="contains(proportional,'False')">

<!-- Make Bitmaps -->
			<xsl:for-each select="bitmap">
				<xsl:text>&#9;</xsl:text>
                <xsl:for-each select="byte">
			<!-- Revision 3/22/14 to correct build of 16-bit words in 0xHHLL order -->
                    <xsl:if test="position() mod 2 = 0">
                        <xsl:value-of select="concat(.,substring(preceding::byte[1], 3, 2))"/>
                        <xsl:if test="position()!=last()">
                        	<xsl:text>,</xsl:text>
                    	</xsl:if>
			        </xsl:if>
			<!-- end 3/22/14 revision -->
                    <xsl:if test="position()=last() and position() mod 2 = 1">
                        <xsl:value-of select="concat(.,'00')"/>
                    </xsl:if>
    	            <xsl:if test="(floor(position() div 16) = position() div 16)">
                        <xsl:if test="position()!=last()">
        			        <xsl:text>&#xa;&#9;</xsl:text>
                        </xsl:if>
		            </xsl:if>
                </xsl:for-each>
				<xsl:if test="position()!=last()">
					<xsl:text>,</xsl:text>
				</xsl:if>


                <xsl:choose>
                    <xsl:when test="bytesperbitmap mod 16 = 0">
                        <xsl:variable name="lastline">
                            <xsl:value-of select="8"/>
                        </xsl:variable>

                    </xsl:when>
                	<xsl:otherwise>
                        <xsl:variable name="lastline">
                        <xsl:choose>
                            <xsl:when test="bytesperbitmap mod 2 = 0">
                                <xsl:value-of select="64 - 8 * ((bytesperbitmap div 2) mod 8)"/>
                            </xsl:when>
                            <xsl:when test="bytesperbitmap mod 2 = 1">
                                <xsl:value-of select="64 - 8 * (((bytesperbitmap + 1) div 2) mod 8)"/>
                            </xsl:when>
                        </xsl:choose>
                        </xsl:variable>
                        <xsl:call-template name="RepeatString">
        				    <xsl:with-param name="string" select="' '" />
	        			    <xsl:with-param name="times"  select="$lastline" />
		        	    </xsl:call-template> 
                    </xsl:otherwise>
                </xsl:choose>



                <xsl:choose>
					<xsl:when test="position()!=last()">
						<xsl:text> // </xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>  // </xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="ShowASCII">
					<xsl:with-param name="shascii" select="$StrtCharacter" />
				</xsl:call-template>
				<xsl:text>&#xa;</xsl:text>

			</xsl:for-each>
		</xsl:if>
		
		<xsl:text>&#xa;};&#xa;</xsl:text>

	</xsl:template>


	<!-- Display corresponding ASCII character -->
	<xsl:template name="ShowASCII">
		<xsl:param name="shascii" />
		<!--                                ................................ !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXUZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~.................................................................................................................................-->
		<xsl:variable name="ascii" select="'................................ !.#$%..()*+,-..0123456789:;.=.?@ABCDEFGHIJKLMNOPQRSTUVWXUZ[.]^_`abcdefghijklmnopqrstuvwxyz{|}~.................................................................................................................................'" />
		<xsl:variable name="n_space" select="33" />
		<xsl:variable name="n_double_quote" select="35" />
		<xsl:variable name="n_ampersand" select="39" />
		<xsl:variable name="n_single_quote" select="40" />
		<xsl:variable name="n_slash" select="48" />
		<xsl:variable name="n_less_than" select="61" />
		<xsl:variable name="n_greater_than" select="63" />
		<xsl:variable name="n_backslash" select="93" />
		<xsl:choose>
			<xsl:when test="$shascii + position() = $n_space">
				<xsl:text>Space     </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_double_quote">
				<xsl:text><![CDATA["]]>         </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_ampersand">
				<xsl:text><![CDATA[&]]>         </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_single_quote">
				<xsl:text><![CDATA[']]>         </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_slash">
				<xsl:text>Slash     </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_less_than">
				<xsl:text><![CDATA[<]]>         </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_greater_than">
				<xsl:text><![CDATA[>]]>         </xsl:text>
			</xsl:when>
			<xsl:when test="$shascii + position() = $n_backslash">
				<xsl:text>Backslash </xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="substring($ascii, $shascii + position(), 1)"/>
    			<xsl:text>         </xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

    <!-- Convert Dezimal to Hex --> 
    <xsl:variable name="hexDigits" select="'0123456789ABCDEF'" />
    <xsl:template name="toHex">
        <xsl:param name="decimalNumber" />
        <xsl:if test="$decimalNumber >= 16">
            <xsl:call-template name="toHex">
                <xsl:with-param name="decimalNumber" select="floor($decimalNumber div 16)" />
            </xsl:call-template>
        </xsl:if>
        <xsl:value-of select="substring($hexDigits, ($decimalNumber mod 16) + 1, 1)" />
    </xsl:template>

	<!-- Make the index with start address of the bitmaps -->
	<xsl:template name="makeIndex">
		<xsl:param name="stchar" />
		<xsl:text>&#9;// Bitmap Index: Number of Index Entries </xsl:text>
			<xsl:value-of select="count(bitmap)"/>
		<xsl:text>&#xa; </xsl:text>
	
		<xsl:variable name="mcount" select="count(bitmap)"/>

		<xsl:for-each select="bitmap">
			<xsl:variable name="laenge">
				<xsl:call-template name="recursivLength">
					<xsl:with-param name="n">
						<xsl:value-of select="position()"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="Word">
					<xsl:value-of select="(((floor($laenge div 256) * 256) + ($laenge mod 256)) div 2) + $mcount + 7"/>
			</xsl:variable>
			<xsl:text>&#9;0x</xsl:text>

    		<xsl:call-template name="AddZero">
				<xsl:with-param name="n" select="$Word" />
			</xsl:call-template>
			
			<xsl:call-template name="toHex">
				<xsl:with-param name="decimalNumber" select="$Word" />
			</xsl:call-template>

			<xsl:text>, // </xsl:text>

			<xsl:call-template name="ShowASCII">
				<xsl:with-param name="shascii" select="$stchar" />
			</xsl:call-template>
		<xsl:text>&#xa;</xsl:text>
		</xsl:for-each>
		<xsl:text>&#xa;</xsl:text>
	</xsl:template>

	<!-- Calculate the bitmap bytes from bitmap 1 to bitmap n -->
	<!-- Remember: XSLT starts indexing with 1 and not with 0 -->
	<xsl:template name="recursivLength">
	   <xsl:param name="n"/>
	   <xsl:if test="$n > 1"> 
				<xsl:variable name="Width" >
					<xsl:call-template name="recursivLength">
                        <xsl:with-param name="n" select="$n - 1"/>
					</xsl:call-template>
				</xsl:variable>
<!--    D Mort start altered following section to correct index generation for 16-bit -->
                <xsl:variable name="BytesPerBitmap">
                    <xsl:value-of select="../bitmap[$n]/bytesperbitmap" />
				</xsl:variable>
                <xsl:if test="$BytesPerBitmap mod 2 = 0"> 
            		<xsl:value-of select="$Width + $BytesPerBitmap + 2" />
        	    </xsl:if>
                <xsl:if test="$BytesPerBitmap mod 2 = 1"> 
        			<xsl:value-of select="$Width + $BytesPerBitmap + 3" />
        	    </xsl:if>
<!--       D Mort end altered section to correct index generation for 16-bit -->

	   </xsl:if>
       <xsl:if test="$n = 1"> 
			<xsl:variable name="Width" >0</xsl:variable> 
			<xsl:value-of select="$Width" />
	   </xsl:if>
	</xsl:template>



	<xsl:template name="RepeatString">
		<xsl:param name="string" select="''" />
		<xsl:param name="times"  select="1" />
		<xsl:if test="number($times) &gt; 0">
			<xsl:value-of select="$string" />
			<xsl:call-template name="RepeatString">
				<xsl:with-param name="string" select="$string" />
				<xsl:with-param name="times"  select="$times - 1" />
			</xsl:call-template>
		</xsl:if>
	</xsl:template> 


    <xsl:template name="AddZero">
	   <xsl:param name="n"/>
        <xsl:if test="$n &lt; 4096">
			<xsl:text>0</xsl:text>
            <xsl:if test="$n &lt; 256">
    			<xsl:text>0</xsl:text>
                <xsl:if test="$n &lt; 16">
    				<xsl:text>0</xsl:text>
	            </xsl:if>
	    	</xsl:if>
		</xsl:if>
    </xsl:template>


 </xsl:stylesheet>